﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BahaTurret;
using UnityEngine;
using NorthKerbinMod;

namespace NorthKerbinMod
{
    public class FireFunction : PartModule
    {
        public float heat;
        public float radius;
        public float time;
        public GameObject fireFX;
        public Vector3 position;
        public Vessel sourceVessel;
        public KSPParticleEmitter fire = new KSPParticleEmitter();
        public KSPParticleEmitter fire2 = new KSPParticleEmitter();

        IEnumerator die(float dieTime)
        {
            yield return new WaitForSeconds(dieTime);
            fireFX.DestroyGameObject();
            gameObject.DestroyGameObject();
        }

        IEnumerator wait(float waitTime)
        {
            yield return new WaitForSeconds(waitTime);
            fire2.emit = false;
            fire.emit = false;
            heat = 0;
        }

        public void Start()
        {
            fire = fireFX.GetComponent<KSPParticleEmitter>();
            fire2 = fireFX.GetComponentInChildren<KSPParticleEmitter>();
            fireFX.SetActive(true);
            fireFX.transform.position = position;
            gameObject.transform.position = position;
            StartCoroutine(wait(20));
            StartCoroutine(die(time));
        }

        public void FixedUpdate()
        {
            foreach(var vessel in BDATargetManager.LoadedVessels)
            {
                if (vessel == null) continue;
                if (vessel.loaded && !vessel.packed && (vessel.transform.position - transform.position).magnitude < radius)
                {
                    foreach (var part in vessel.parts)
                    {
                        if (!part) continue;
                        part.temperature += heat;
                    }
                }
            }
        }
    }
}
