﻿using BahaTurret;
using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NorthKerbinMod
{
    public class ModuleNuclearExplosive : PartModule
    {
        [KSPField(isPersistant = false)]
        public float baseRadius = 1;

        [KSPField(isPersistant = false)]
        public float blastRadius = 1000;

        [KSPField(isPersistant = false)]
        public float blastPower = 100;

        [KSPField(isPersistant = false)]
        public string explGroundPath = "North Kerbin Weaponry/effects/Explosion_KBW";

        [KSPField(isPersistant = false)]
        public string explSoundPath = "North Kerbin Weaponry/sounds/explosion_MOAB";

        [KSPField(isPersistant = false)]
        public string fireModelPath = "North Kerbin Weaponry/effects/fire_basic";

        [KSPField(isPersistant = false)]
        public bool usingNapalm = false;

        [KSPField(isPersistant = false)]
        public float flameRadius = 100;

        [KSPField(isPersistant = false)]
        public float flamePower = 25;

        [KSPField(isPersistant = false)]
        public float flameTime = 10;

        [KSPField(isPersistant = true, guiActive = true, guiActiveEditor = true, guiName = "Arm Time")]
        [UI_FloatRange(minValue = 5f, maxValue = 30f, stepIncrement = 1f)]
        float armTime = 5;

        [KSPAction("Detonate")]
        public void DetonateAG(KSPActionParam param)
        {
            Detonate();
        }


        bool hasDetonated = false;
        MissileLauncher weapon;

        public override void OnStart(PartModule.StartState state)
        {
                part.OnJustAboutToBeDestroyed += new Callback(Detonate);
                part.force_activate();
        }

        public override void OnInitialize()
        {
            weapon = GetComponent<MissileLauncher>();
        }

        public void Detonate()
        {
            if (!hasDetonated && weapon.timeFired >= armTime)
            {
                hasDetonated = true;
                if (part != null) part.temperature = part.maxTemp + 100;
                Vector3 position = transform.position + part.rb.velocity * Time.fixedDeltaTime;

                if (usingNapalm) HarpExplosionFX.CreateNewNapalmFire(position, flameRadius, flamePower, flameTime, vessel, FlightGlobals.getUpAxis(), fireModelPath);

                HarpExplosionFX.CreateNewProgressiveExplosion(position, baseRadius, blastRadius, blastPower, vessel, FlightGlobals.getUpAxis(), explGroundPath, "BDArmory/Sounds/explode1");
            }
        }
    }
}
