﻿using BahaTurret;
using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NorthKerbinMod
{
    public class ModuleKineticBombarder : PartModule
    {
        [KSPField(isPersistant = false)]
        public float baseBlastRadius = 5;

        [KSPField(isPersistant = false)]
        public float baseBlastPower = 5;

        [KSPField(isPersistant = false)]
        public float baseRadius = 1;

        [KSPField(isPersistant = false)]
        public string explModelPath = "North Kerbin Weaponry/effects/Explosion_KBW";

        [KSPField(isPersistant = false)]
        public string explModelAir = "North Kerbin Weaponry/effects/Explosion_KBW";

        [KSPField(isPersistant = false)]
        public string explModelSpace = "North Kerbin Weaponry/effects/Explosion_KBW";

        public bool hasDetonated = false;

        public float blastRadius;
        public float blastPower;

        public void CalculateBlast()
        {
            blastPower = baseBlastPower * (0.5f * part.mass * (0.1f * part.rb.velocity.magnitude));
            blastRadius = baseBlastRadius * (part.rb.velocity.magnitude * 0.05f);
            Debug.Log("Blast Wickedness: " + blastPower);
        }

        public override void OnFixedUpdate()
        {
            CalculateBlast();
            Debug.Log("Blast Wickedness: " + blastPower);
        }

        public override void OnStart(PartModule.StartState state)
        {
            part.OnJustAboutToBeDestroyed += new Callback(Detonate);
            part.force_activate();
        }

        public void Detonate()
        {
            if (!hasDetonated)
            {
                CalculateBlast();
                hasDetonated = true;
                if (part != null)
                {
                    part.temperature = part.maxTemp + 100;
                }
                Vector3 position = transform.position + part.rb.velocity * Time.fixedDeltaTime;
                HarpExplosionFX.CreateNewProgressiveExplosion(position, baseRadius, blastRadius, blastPower, vessel, FlightGlobals.getUpAxis(), explModelPath, "BDArmory/Sounds/explode1");
            }
        }
    }
}
