﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BahaTurret;
using UnityEngine;

namespace NorthKerbinMod
{
    class HarpNapalm : PartModule
    {
        [KSPField(isPersistant = false)]
        public string explSoundPath = "North Kerbin Weaponry/sounds/explosion_MOAB";

        [KSPField(isPersistant = false)]
        public string fireModelPath = "North Kerbin Weaponry/effects/fire_basic";

        [KSPField(isPersistant = false)]
        public float flameRadius = 100;

        [KSPField(isPersistant = false)]
        public float flameHeat = 25;

        [KSPField(isPersistant = false)]
        public float flameTime = 10;

        [KSPAction("Detonate")]
        public void DetonateAG(KSPActionParam param)
        {
            Detonate();
        }


        bool hasDetonated = false;
        MissileLauncher weapon;

        public override void OnStart(PartModule.StartState state)
        {
            part.OnJustAboutToBeDestroyed += new Callback(Detonate);
            part.force_activate();
        }

        public override void OnInitialize()
        {
            weapon = GetComponent<MissileLauncher>();
        }

        public void Detonate()
        {
            if (!hasDetonated)
            {
                hasDetonated = true;
                if (part != null) part.temperature = part.maxTemp + 100;
                Vector3 position = transform.position;

                HarpExplosionFX.CreateNewNapalmFire(position, flameRadius, flameHeat, flameTime, vessel, FlightGlobals.getUpAxis(), fireModelPath);
            }
        }
    }
}
