﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BahaTurret;
using UnityEngine;

namespace NorthKerbinMod
{
    public class HarpExplosionFX : ExplosionFX
    {
        public static void CreateNewNapalmFire(Vector3 position, float radius, float heat, float time, Vessel sourceVessel, Vector3 direction, string fireModelPath)
        {
            GameObject fire;

            fire = GameDatabase.Instance.GetModel(fireModelPath);
            Quaternion rotation = Quaternion.LookRotation(VectorUtils.GetUpDirection(position));

            GameObject fireCenter = new GameObject();
            fireCenter.SetActive(true);
            fireCenter.transform.parent = null;
            fireCenter.transform.position = fire.transform.position;
            FireFunction flames = fireCenter.AddComponent<FireFunction>();
            fireCenter.GetComponent<FireFunction>().enabled = true;
            flames.radius = radius;
            flames.position = position;
            flames.heat = heat;
            flames.time = time;
            flames.sourceVessel = sourceVessel;
            flames.fireFX = (GameObject)GameObject.Instantiate(fire, position, rotation);
        }

        public static void CreateNewProgressiveExplosion(Vector3 position, float baseRadius, float radius, float power, Vessel sourceVessel, Vector3 direction, string explModelPath, string soundPath)
        {
            GameObject expl = GameDatabase.Instance.GetModel(explModelPath);
            AudioClip sound = GameDatabase.Instance.GetAudioClip(soundPath);

            Quaternion rotation = Quaternion.LookRotation(VectorUtils.GetUpDirection(position));

            GameObject shockCenter = new GameObject();
            shockCenter.SetActive(true);
            shockCenter.transform.parent = null;
            shockCenter.transform.position = expl.transform.position;
            progressiveExplosion ProgExplosion = shockCenter.AddComponent<progressiveExplosion>();
            shockCenter.GetComponent<progressiveExplosion>().enabled = true;
            ProgExplosion.radius = radius;
            ProgExplosion.baseRadius = baseRadius;
            ProgExplosion.power = power;
            ProgExplosion.rotation = rotation;
            ProgExplosion.position = position;
            ProgExplosion.sourceVessel = sourceVessel;
            Debug.Log("Values Set");

            GameObject newExplosion = (GameObject)GameObject.Instantiate(expl, position, rotation);
            newExplosion.SetActive(true);
            ExplosionFX eFx = newExplosion.AddComponent<ExplosionFX>();
            eFx.exSound = sound;
            eFx.audioSource = newExplosion.AddComponent<AudioSource>();
            eFx.audioSource.minDistance = 50;
            eFx.audioSource.maxDistance = 5000;

            if (power <= 5)
            {
                eFx.audioSource.minDistance = 4f;
                eFx.audioSource.maxDistance = 1000;
                eFx.audioSource.priority = 9999;
            }
            foreach (KSPParticleEmitter pe in newExplosion.GetComponentsInChildren<KSPParticleEmitter>())
            {
                pe.emit = true;
            }
        }
    }
}
